\begin{ManPage}{\label{man-condor-q}\Condor{q}}{1}
{Display information about jobs in queue}

\index{HTCondor commands!condor\_q}
\index{condor\_q command}

\Synopsis \SynProg{\Condor{q}}
\oOpt{-help [Universe | State]} 

\SynProg{\Condor{q}}
\ToolDebugOption
\oArg{general options}
\oArg{restriction list}
\oArg{output options}
\oArg{analyze options}

\Description
\Condor{q} displays information about jobs in the HTCondor job queue.  By
default, \Condor{q} queries the local job queue,
but this behavior may be 
modified by specifying one of the general options.

To restrict the display to jobs of interest, a list of zero or more 
restriction options may be supplied.  Each restriction may be one of:
\begin{itemize}
	\item a \Arg{cluster} and a \Arg{process} matches jobs which
		belong to the specified cluster and have the specified process number
	\item a \Arg{cluster} without a \Arg{process} matches all jobs belonging
		to the specified cluster
	\item an \Arg{owner} matches all jobs owned by the specified owner
	\item a \OptArg{-constraint}{expression} which matches all jobs that
		satisfy the specified ClassAd expression. 
\end{itemize}
If no restrictions are present in the list to specify an
\Arg{owner}, the job matches the 
restriction list if it matches at least one restriction in the list.  If 
\Arg{owner} restrictions are present, the job matches the list if it matches 
one of the \Arg{owner} restrictions \emph{and} at least one non-\Arg{owner} 
restriction.

If the \Opt{-long} option is specified, \Condor{q} displays a long description 
of the queried jobs by printing the entire job ClassAd.
The attributes of the job ClassAd may be displayed by means of the
\Opt{-format} option, which displays attributes with a \verb+printf(3)+
format.
Multiple \Opt{-format} options may be specified in the option list to display
several attributes of the job.
If neither \Opt{-long} or \Opt{-format} are specified, \Condor{q} displays a 
one line summary of information as follows:

\begin{description}
\item[ID] The cluster/process id of the condor job. 
\item[OWNER] The owner of the job. 
\item[SUBMITTED] The month, day, hour, and minute the job was submitted to the 
	queue. 
\item[RUN\_TIME]  Wall-clock time accumulated by the job to date in days, 
	hours, minutes, and seconds.  
\item[ST] Current status of the job, which varies somewhat according
        to the job universe and the timing of updates.
        H = on hold,
        R = running,
%	S = suspended,
	I = idle
        (waiting for a machine to execute on), C = completed, 
        X = removed,
		S = suspended (execution of a running job temporarily suspended on execute node),
        < = transferring input (or queued to do so), and
        > = transferring output (or queued to do so). 
\item[PRI] User specified priority of the job, displayed as an integer, with 
	higher numbers corresponding to greater priority. 
\item[SIZE] The peak amount of memory in Mbytes consumed by the job; note
	this value is only refreshed periodically.  The actual value reported is
	taken from the job ClassAd attribute \Attr{MemoryUsage} if this attribute
	is defined, and from job attribute \Attr{ImageSize} otherwise.
\item[CMD] The name of the executable. 
\end{description}

If the output option \Opt{-dag} is specified, the OWNER column is replaced
with NODENAME for jobs started by the \Condor{dagman} instance.

If the output option \Opt{-run} is specified, the ST, PRI, SIZE, and CMD
columns are replaced with:

\begin{description}
\item[HOST(S)] The host where the job is running.
\end{description}

If the output option \Opt{-globus} is specified, the ST, PRI, SIZE, and CMD
columns are replaced with:
\begin{description}
\item[STATUS] The state that HTCondor believes the job is in.
Possible values are
  \begin{description}
    \item[PENDING] The job is waiting for resources to become available
    in order to run.
    \item[ACTIVE] The job has received resources, and the application
    is executing.
    \item[FAILED] The job terminated before completion because of an error,
    user-triggered cancel, or system-triggered cancel.
    \item[DONE] The job completed successfully.
    \item[SUSPENDED] The job has been suspended.
    Resources which were allocated for this job may have been
    released due to a scheduler-specific reason.
    \item[UNSUBMITTED] The job has not been submitted to the scheduler yet,
    pending the reception of the 
    GLOBUS\_GRAM\_PROTOCOL\_JOB\_SIGNAL\_COMMIT\_REQUEST signal from a client.
    \item[STAGE\_IN] The job manager is staging in files,
    in order to run the job.
    \item[STAGE\_OUT] The job manager is staging out files
    generated by the job.
    \item[UNKNOWN]
  \end{description}
\item[MANAGER] 
A guess at what remote batch system is running the job.
It is a guess, because HTCondor looks at the Globus jobmanager contact
string to attempt identification.
If the value is fork, the job is running on the
remote host without a jobmanager.
Values may also be condor, lsf, or pbs.
\item[HOST] The host to which the job was submitted.
\item[EXECUTABLE] The job as specified as the executable in the
submit description file.
\end{description}

If the output option \Opt{-goodput} is specified, the ST, PRI, SIZE, and CMD
columns are replaced with:

\begin{description}
\item[GOODPUT] The percentage of RUN\_TIME for this job which has been
saved in a checkpoint.  A low GOODPUT value indicates that the job is
failing to checkpoint.  If a job has not yet attempted a checkpoint,
this column contains \texttt{[?????]}.
\item[CPU\_UTIL] The ratio of CPU\_TIME to RUN\_TIME for checkpointed
work.  A low CPU\_UTIL indicates that the job is not running
efficiently, perhaps because it is I/O bound or because the job
requires more memory than available on the remote workstations.  If
the job has not (yet) checkpointed, this column contains \texttt{[??????]}.
\item[Mb/s] The network usage of this job, in Megabits per second of
run-time.
\end{description}

If the output option \Opt{-io} is specified, the ST, PRI, SIZE, and CMD columns
are replaced with:

\begin{description}
\item{READ} The total number of bytes the application has read from files and sockets.
\item{WRITE} The total number of bytes the application has written to files and sockets.
\item{SEEK} The total number of seek operations the application has performed on files.
\item{XPUT} The effective throughput (average bytes read and written per second)
from the application's point of view.
\item{BUFSIZE} The maximum number of bytes to be buffered per file.
\item{BLOCKSIZE} The desired block size for large data transfers.
\end{description}

These fields are updated when a job produces a checkpoint or completes.
If a job
has not yet produced a checkpoint, this information is not available.

If the output option \Opt{-cputime} is specified, the RUN\_TIME 
column is replaced with:

\begin{description}
\item[CPU\_TIME] The remote CPU time accumulated by the job to date
(which has been stored in a checkpoint) in days, hours, minutes, and
seconds.  (If the job is currently running, time accumulated during
the current run is \emph{not} shown.  If the job has not produced a checkpoint,
this column contains 0+00:00:00.)
\end{description}

The \Opt{-analyze} or \Opt{-better-analyze} options may be used to determine 
why certain jobs are not
running by performing an analysis on a per machine basis for each machine in 
the pool.  The reasons may vary among failed constraints, insufficient priority,
resource owner preferences and prevention of preemption by the 
\Macro{PREEMPTION\_REQUIREMENTS} expression.  
If the analyze option \Opt{-verbose} is specified 
along with the \Opt{-analyze} option, the reason for failure is displayed on a 
per machine basis. 
\Opt{-better-analyze} differs from \Opt{-analyze} in that it will
do matchmaking analysis on jobs even if they are currently running, 
or if the reason they are not running is not due to matchmaking.
\Opt{-better-analyze} also produces
more thorough analysis of complex Requirements and shows the values of 
relevant job ClassAd attributes.  
When only a single machine is being analyzed via \Opt{-machine} or
\Opt{-mconstraint},
the values of relevant attributes of the machine ClassAd are also displayed.

\begin{Options}
  \ToolDebugDesc
  \OptItem{\Opt{-global}}{(general option) Queries all job queues in the pool.}
  \OptItem{\OptArg{-submitter}{submitter}}{(general option) List jobs of 
    a specific submitter.} 
  \OptItem{\OptArg{-name}{name}}{(general option) Query only the job queue 
    of the named \Condor{schedd} daemon. }
  \OptItem{\OptArg{-pool}{centralmanagerhostname[:portnumber]}}
    {(general option) Use the \Argnm{centralmanagerhostname} as 
    the central manager to locate \Condor{schedd} daemons.
    The default is the \MacroNI{COLLECTOR\_HOST},
    as specified in the configuration.}
  \OptItem{\OptArg{-jobads}{file}}{(general option) Display jobs from a list of
    ClassAds from a file, instead of the real ClassAds from the
    \Condor{schedd} daemon.
    This is most useful for debugging purposes.
    The ClassAds appear as if
    \Condor{q} \Opt{-long} is used with the header stripped out.}
  \OptItem{\OptArg{-userlog}{file}}{(general option) 
    Display jobs, with job information coming from a job event log,
    instead of from the real ClassAds from the \Condor{schedd} daemon.
    This is most useful for automated testing of the status of jobs known to be
    in the given job event log, because it reduces the load on the \Condor{schedd}.
    A job event log does not contain all of the job information, so some fields in
    the normal output of \Condor{q} will be blank.}
  \OptItem{\Opt{-autocluster}} {(output option) 
    Output \Condor{schedd} daemon auto cluster information.
    For each auto cluster,
    output the unique ID of the auto cluster
    along with the number of jobs in that auto cluster. 
    This option is intended to be used together with the \Opt{-long} option
    to output the ClassAds representing auto clusters.  
    The ClassAds can then be used to identify or classify the demand for
    sets of machine resources, 
    which will be useful in the on-demand creation of execute nodes for
    glidein services. } 
  \OptItem{\Opt{-cputime}} {(output option) 
    Instead of wall-clock allocation time (RUN\_TIME), 
    display remote CPU time accumulated by the job to date in days,
    hours, minutes, and seconds.  If the job is currently running, time
    accumulated during the current run is \emph{not} shown.}
  \OptItem{\Opt{-currentrun}} {(output option)
    Normally, RUN\_TIME contains all the time
    accumulated during the current run plus all previous runs.  If this
    option is specified, RUN\_TIME only displays the time accumulated so
    far on this current run.}
  \OptItem{\OptArg{-dag}{<DAG-ID>}} {(output option) Display DAG node jobs 
    under their DAGMan instance.
    Child nodes are listed using indentation to show the structure
    of the DAG. 
    When the optional \Arg{DAG-ID} is specified, display all jobs in the DAG. }
  \OptItem{\Opt{-expert}}{(output option) Display shorter error messages. }
  \OptItem{\Opt{-globus}}{(output option) Get information only about 
    jobs submitted to grid resources described as \SubmitCmdNI{gt2}
    or \SubmitCmdNI{gt5}.}
  \OptItem{\Opt{-goodput}}{(output option) Display job goodput statistics.}
  \OptItem{\Opt{-help [Universe | State]}}{(output option) Print usage info, 
    and additionally print job universes or job states.}
  \OptItem{\Opt{-hold}}{(output option) Get information about jobs in 
    the hold state.
    Also displays the time the job was placed into the hold state
    and the reason why the job was placed in the hold state.}
  \OptItem{\OptArg{-limit}{Number}}{(output option) 
    Limit the number of items output to \Arg{Number}. }
  \OptItem{\Opt{-io}}{(output option) Display job input/output summaries.}
  \OptItem{\Opt{-long}}{(output option) Display entire job ClassAds 
    in long format.}
  \OptItem{\Opt{-run}}{(output option) Get information about running jobs.}
  \OptItem{\Opt{-stream-results}}{(output option)
    Display results as jobs are fetched
    from the job queue rather than storing results in memory until all
    jobs have been fetched.  This can reduce memory consumption when fetching
    large numbers of jobs, but if \Condor{q} is paused while displaying
    results, this could result in a timeout in communication with
    \Condor{schedd}.}
  \OptItem{\Opt{-totals}}{(output option) Display only the totals.}
  \OptItem{\Opt{-version}}{(output option) Print the HTCondor version and exit.}
  \OptItem{\Opt{-wide}}{(output option) If this option is specified, 
    and the command portion
    of the output would cause the output to extend beyond 80 columns,
    display beyond the 80 columns. }
  \OptItem{\Opt{-xml}}{(output option) Display entire job ClassAds 
    in XML format.
    The XML format is fully defined in the reference manual,
    obtained from the ClassAds web page, with a link at
    \URL{http://htcondor.org/classad/classad.html}.}
  \OptItem{\OptArg{-attributes}{Attr1[,Attr2 \Dots]}}{(output option)
    Explicitly list the attributes, 
    by name in a comma separated list,
    which should be displayed when using the \Opt{-xml} or \Opt{-long} options.
    Limiting the number of attributes increases the efficiency of the query.}
  \OptItem{\OptArg{-format}{fmt attr}}{(output option) Display attribute or 
    expression \Arg{attr} in format \Arg{fmt}.
    To display the attribute or expression the format must contain a single
    \Code{printf(3)}-style conversion specifier.
    Attributes must be from the job ClassAd.
    Expressions are ClassAd expressions and may 
    refer to attributes in the job ClassAd.
    If the attribute is not present in a given ClassAd and cannot
    be parsed as an expression,
    then the format option will be silently skipped.
    \%r prints the unevaluated, or raw values.
    The conversion specifier must match the type of the
    attribute or expression.
    \%s is suitable for strings such as \Attr{Owner},
    \%d for integers such as \Attr{ClusterId},
    and \%f for floating point numbers such as \Attr{RemoteWallClockTime}.  
    \%v identifies the type of the attribute,
    and then prints the value in an appropriate format.
    \%V identifies the type of the attribute,
    and then prints the value in an appropriate format as it would
    appear in the \Opt{-long} format.
    As an example, strings used with \%V will have quote marks.
    An incorrect format will result in undefined behavior.
    Do not use more than one conversion specifier in a given
    format.  More than one conversion specifier will result
    in undefined behavior.  To output multiple attributes
    repeat the \Opt{-format} option once for each desired attribute.
    Like {\Code{printf(3)}} style formats, one may include other
    text that will be reproduced directly.   
    A format without any conversion specifiers may be specified,
    but an attribute is still required.
    Include \Bs n to specify a line break. }

  \OptItem{\OptArg{-autoformat[:jlhVr,tng]}{attr1 [attr2 ...]} 
  or \OptArg{-af[:jlhVr,tng]}{attr1 [attr2 ...]}} {
    (output option) Display attribute(s) or expression(s)
    formatted in a default way according to attribute types.  
    This option takes an arbitrary number of attribute names as arguments,
    and prints out their values, 
    with a space between each value and a newline character after 
    the last value.  
    It is like the \Opt{-format} option without format strings.
    This output option does \emph{not} work in conjunction with any of the
    options \Opt{-run}, \Opt{-currentrun}, \Opt{-hold}, 
    \Opt{-globus}, \Opt{-goodput}, or \Opt{-io}.

    It is assumed that no attribute names begin with a dash character,
    so that the next word that begins with dash is the 
    start of the next option.
    The \Opt{autoformat} option may be followed by a colon character
    and formatting qualifiers to deviate the output formatting from
    the default:

    \textbf{j} print the job ID as the first field,

    \textbf{l} label each field,

    \textbf{h} print column headings before the first line of output,

    \textbf{V} use \%V rather than \%v for formatting (string values
    are quoted),

    \textbf{r} print "raw", or unevaluated values,

    \textbf{,} add a comma character after each field,

    \textbf{t} add a tab character before each field instead of 
    the default space character,

    \textbf{n} add a newline character after each field,

    \textbf{g} add a newline character between ClassAds, and
    suppress spaces before each field.

    Use \textbf{-af:h} to get tabular values with headings.

    Use \textbf{-af:lrng} to get -long equivalent format.

    The newline and comma characters may \emph{not} be used together.
    The \textbf{l} and \textbf{h} characters may \emph{not} be used
    together.
    }
  \OptItem{\Opt{-analyze[:<qual>]}}{(analyze option) Perform a matchmaking 
    analysis on why the requested jobs are not running.
    First a simple analysis determines if the job is not running 
    due to not being in a runnable state.
    If the job is in a runnable state, then this option is equivalent
    to \Opt{-better-analyze}.
    \Opt{<qual>} is a comma separated list containing one or more of

    \textbf{priority} to consider user priority during the analysis

    \textbf{summary} to show a one line summary for each job or machine

    \textbf{reverse} to analyze machines, rather than jobs
    }
  \OptItem{\Opt{-better-analyze[:<qual>]}}{(analyze option) 
    Perform a more detailed matchmaking analysis to determine how
    many resources are available to run the requested jobs.
    This option
    is never meaningful for Scheduler universe jobs and only meaningful
    for grid universe jobs doing matchmaking.
    \Opt{<qual>} is a comma separated list containing one or more of

    \textbf{priority} to consider user priority during the analysis

    \textbf{summary} to show a one line summary for each job or machine

    \textbf{reverse} to analyze machines, rather than jobs
    }
  \OptItem{\OptArg{-machine}{name}}{(analyze option)
    When doing matchmaking analysis, 
    analyze only machine ClassAds that have slot or machine names 
    that match the given name. }
  \OptItem{\OptArg{-mconstraint}{expression}}{(analyze option)
    When doing matchmaking analysis, 
    match only machine ClassAds which match the ClassAd expression constraint.}
  \OptItem{\OptArg{-slotads}{file}}{(analyze option)
    When doing matchmaking analysis, use the
    machine ClassAds from the file instead of the ones from the
    \Condor{collector} daemon. 
    This is most useful for debugging purposes. 
    The ClassAds appear as if \Condor{status} \Opt{-long} is used.}
  \OptItem{\OptArg{-userprios}{file}}{(analyze option)
    When doing matchmaking analysis with
    priority, read user priorities from the file rather than the ones from
    the \Condor{negotiator} daemon.
    This is most useful for debugging purposes or to
    speed up analysis in situations where the \Condor{negotiator} daemon is
    slow to respond to \Condor{userprio} requests.  The file should be in 
    the format produced by \Condor{userprio} \Opt{-long}.  }
  \OptItem{\Opt{-nouserprios}}{(analyze option)
    Do not consider user priority during the analysis. }
  \OptItem{\Opt{-reverse}}{(analyze option) 
    Analyze machine requirements against jobs.  }
  \OptItem{\Opt{-verbose}}{(analyze option) 
    When doing analysis, show progress and include
    the names of specific machines in the output.  }
\end{Options}

\GenRem

The default output from \Condor{q} is formatted to be human readable,
not script readable.
In an effort to make the output fit within 80 characters, values in
some fields might be truncated.
Furthermore, the HTCondor Project can (and does) change the formatting
of this default output as we see fit.
Therefore, any script that is attempting to parse data from \Condor{q}
is strongly encouraged to use the \Opt{-format} option (described
above, examples given below).

Although \Arg{-analyze} provides a very good first approximation, the analyzer 
cannot diagnose all possible situations,
because the analysis is based on 
instantaneous and local information.  Therefore, there are some situations 
such as when several submitters are contending for resources, or if the pool 
is rapidly changing state which cannot be accurately diagnosed.

Options
\Opt{-goodput}, \Opt{-cputime}, and \Opt{-io} are most useful for standard
universe jobs, since they rely on values computed when a job
produces a checkpoint.

It is possible to to hold jobs that are in the X state.
To avoid this it 
is best to construct a \OptArg{-constraint}{expression} that option contains
\Expr{JobStatus != 3} if the user wishes to avoid this condition. 

\Examples

The \Opt{-format} option provides a way to specify both the job attributes
and formatting of those attributes.
There must be only one conversion specification per \Opt{-format} option.
As an example, to list only Jane Doe's jobs in the queue,
choosing to print and format only the owner of the job,
the command line arguments for the job, and the
process ID of the job:
\footnotesize
\begin{verbatim}
%condor_q -submitter jdoe -format "%s" Owner -format " %s " Args -format "ProcId = %d\n" ProcId
jdoe 16386 2800 ProcId = 0
jdoe 16386 3000 ProcId = 1
jdoe 16386 3200 ProcId = 2
jdoe 16386 3400 ProcId = 3
jdoe 16386 3600 ProcId = 4
jdoe 16386 4200 ProcId = 7
\end{verbatim}
\normalsize

To display only the JobID's of Jane Doe's jobs you can use the following.
\footnotesize
\begin{verbatim}
%condor_q -submitter jdoe -format "%d." ClusterId -format "%d\n" ProcId
27.0
27.1
27.2
27.3
27.4
27.7
\end{verbatim}
\normalsize

An example that shows the difference (first set of output)
between not using an option to \Condor{q} and (second
set of output) using the \Opt{-globus} option:
\footnotesize
\begin{verbatim}

 ID      OWNER            SUBMITTED     RUN_TIME ST PRI SIZE CMD
 100.0   smith          12/11 13:20   0+00:00:02 R  0   0.0  sleep 10

1 jobs; 0 idle, 1 running, 0 held



 ID      OWNER          STATUS  MANAGER  HOST                EXECUTABLE
 100.0   smith         ACTIVE fork     grid.example.com       /bin/sleep
\end{verbatim}
\normalsize

An example that shows the analysis in summary format:
\footnotesize
\begin{verbatim}
$ condor_q -analyze:summary

-- Submitter: submit-1.chtc.wisc.edu : <192.168.100.43:9618?sock=11794_95bb_3> :
 submit-1.chtc.wisc.edu
Analyzing matches for 5979 slots
            Autocluster  Matches    Machine     Running  Serving
 JobId     Members/Idle  Reqmnts  Rejects Job  Users Job Other User Avail Owner
---------- ------------ -------- ------------ ---------- ---------- ----- -----
25764522.0  7/0             5910        820   7/10       5046        34   smith
25764682.0  9/0             2172        603   9/9        1531        29   smith
25765082.0  18/0            2172        603   18/9       1531        29   smith
25765900.0  1/0             2172        603   1/9        1531        29   smith 
\end{verbatim}
\normalsize

An example that shows summary information by machine:
\footnotesize
\begin{verbatim}
$ condor_q -ana:sum,rev

-- Submitter: s-1.chtc.wisc.edu : <192.168.100.43:9618?sock=11794_95bb_3> : s-1.chtc.wisc.edu
Analyzing matches for 2885 jobs
                                Slot  Slot's Req    Job's Req     Both
Name                            Type  Matches Job  Matches Slot    Match %
------------------------        ---- ------------  ------------ ----------
slot1@INFO.wisc.edu             Stat         2729  0                  0.00
slot2@INFO.wisc.edu             Stat         2729  0                  0.00
slot1@aci-001.chtc.wisc.edu     Part            0  2793               0.00
slot1_1@a-001.chtc.wisc.edu     Dyn          2644  2792              91.37
slot1_2@a-001.chtc.wisc.edu     Dyn          2623  2601              85.10
slot1_3@a-001.chtc.wisc.edu     Dyn          2644  2632              85.82
slot1_4@a-001.chtc.wisc.edu     Dyn          2644  2792              91.37
slot1@a-002.chtc.wisc.edu       Part            0  2633               0.00
slot1_10@a-002.chtc.wisc.edu    Den          2623  2601              85.10 
\end{verbatim}
\normalsize

\ExitStatus

\Condor{q} will exit with a status value of 0 (zero) upon success,
and it will exit with the value 1 (one) upon failure.

\end{ManPage}
